commit 21076167d7a67dc33ba671ce89b36f1be9ef2e51
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Feb 4 17:36:52 2019 +0100

    Applied minor enhancements to all drivers.
    Please note: multiple functions should (and will) be moved from the .c sources to the header files as inline functions soon.

diff --git a/source/alld_at42qt1050.c b/source/alld_at42qt1050.c
index 62e8de9..8d751d1 100644
--- a/source/alld_at42qt1050.c
+++ b/source/alld_at42qt1050.c
@@ -64,8 +64,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @return    Indicator whether the function call was successful or a timeout occurred.
  */
-inline apalExitStatus_t
-at42qt1050_lld_read_reg(const AT42QT1050Driver* at42qt1050d, const at42qt1050_lld_register_t reg, uint8_t* const data, const apalTime_t timeout)
+apalExitStatus_t at42qt1050_lld_read_reg(const AT42QT1050Driver* at42qt1050d, const at42qt1050_lld_register_t reg, uint8_t* const data, const apalTime_t timeout)
 {
   apalDbgAssert(at42qt1050d != NULL && at42qt1050d->i2cd != NULL);
   apalDbgAssert(data != NULL);
@@ -84,8 +83,7 @@ at42qt1050_lld_read_reg(const AT42QT1050Driver* at42qt1050d, const at42qt1050_ll
  *
  * @return    Indicator whether the function call was successful or a timeout occurred.
  */
-inline apalExitStatus_t
-at42qt1050_lld_write_reg(const AT42QT1050Driver* at42qt1050d, const at42qt1050_lld_register_t reg, const uint8_t data, const apalTime_t timeout)
+apalExitStatus_t at42qt1050_lld_write_reg(const AT42QT1050Driver* at42qt1050d, const at42qt1050_lld_register_t reg, const uint8_t data, const apalTime_t timeout)
 {
   apalDbgAssert(at42qt1050d != NULL && at42qt1050d->i2cd != NULL);
 
@@ -103,8 +101,7 @@ at42qt1050_lld_write_reg(const AT42QT1050Driver* at42qt1050d, const at42qt1050_l
  *
  * @return    Indicator whether the function call was successful or a timeout occurred.
  */
-inline apalExitStatus_t
-at42qt1050_lld_read_keyssignal(const AT42QT1050Driver* at42qt1050d, const uint8_t key, uint16_t* signal, const apalTime_t timeout)
+apalExitStatus_t at42qt1050_lld_read_keyssignal(const AT42QT1050Driver* at42qt1050d, const uint8_t key, uint16_t* signal, const apalTime_t timeout)
 {
   apalDbgAssert(at42qt1050d != NULL && at42qt1050d->i2cd != NULL);
   apalDbgAssert(key < AT42QT1050_LLD_NUM_KEYS);
@@ -127,8 +124,7 @@ at42qt1050_lld_read_keyssignal(const AT42QT1050Driver* at42qt1050d, const uint8_
  *
  * @return    Indicator whether the function call was successful or a timeout occurred.
  */
-inline apalExitStatus_t
-at42qt1050_lld_read_referencedata(const AT42QT1050Driver* at42qt1050d, const uint8_t key, uint16_t* refdata, const apalTime_t timeout)
+apalExitStatus_t at42qt1050_lld_read_referencedata(const AT42QT1050Driver* at42qt1050d, const uint8_t key, uint16_t* refdata, const apalTime_t timeout)
 {
   apalDbgAssert(at42qt1050d != NULL && at42qt1050d->i2cd != NULL);
   apalDbgAssert(key < AT42QT1050_LLD_NUM_KEYS);
@@ -149,8 +145,7 @@ at42qt1050_lld_read_referencedata(const AT42QT1050Driver* at42qt1050d, const uin
  *
  * @return    Resulting sample count.
  */
-inline uint16_t
-at42qt1050_lld_pulse2samples(const uint8_t pulse)
+uint16_t at42qt1050_lld_pulse2samples(const uint8_t pulse)
 {
   apalDbgAssert(pulse <= 0x0Fu);
 
@@ -165,8 +160,7 @@ at42qt1050_lld_pulse2samples(const uint8_t pulse)
  *
  * @return    The (theoretical) value to set to the pulse register.
  */
-inline float
-at42qt1050_lld_samples2pulse(const uint16_t samples)
+float at42qt1050_lld_samples2pulse(const uint16_t samples)
 {
   return log2f(samples);
 }
@@ -179,8 +173,7 @@ at42qt1050_lld_samples2pulse(const uint16_t samples)
  *
  * @return    Resulting scaling factor.
  */
-inline uint16_t
-at42qt1050_lld_scale2scaling(const uint8_t scale)
+uint16_t at42qt1050_lld_scale2scaling(const uint8_t scale)
 {
   apalDbgAssert(scale <= 0x0Fu);
 
@@ -195,8 +188,7 @@ at42qt1050_lld_scale2scaling(const uint8_t scale)
  *
  * @return    The (theoretcial) value to set to the scale register.
  */
-inline float
-at42qt1050_lld_scaling2scale(const uint16_t factor)
+float at42qt1050_lld_scaling2scale(const uint16_t factor)
 {
   return log2f(factor);
 }